#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_mssql_eventrpt.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================

$debug = 1;
$| = 1;
$P = "dbamon_mssql_eventrpt.pl";

##$log = "/opt/dbamon/log/${P}.log";

$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";

$tmpflrpt = "/tmp/dbamon_mssql_eventrpt_1_$$.txt";
##$tmpflemail = "/tmp/dbamon_mssql_eventrpt_2_$$.txt";

$days = 5;
$img = "http://dbamon.com/images/blue.gif";
$font = "arial"; 
$style_s = " style='font-family:$font;font-size:10' "; 
$style_m = " style='font-family:$font;font-size:12' "; 
$style_l = " style='font-family:$font;font-size:15' "; 

$color_body = "linen"; 
$color_th = "cadetblue"; 
$color_ba = "wheat"; 
$color_ro = "white"; 

$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};

$mode = uc $ARGV[0];
$modelc = lc $mode;
if ($mode eq "") { $mode = "PROD"; }
$modesuf = "_test" if $modelc eq "test"; 

#---- Read WWW_URL
chop($www_base = `grep '^WWW_URL:' /opt/dbamon/adm/dbamonrc$modesuf | awk '{ print \$2 }'`);

#---- Read first email address
chop($admin_email = `grep '^Admin_EMail:' /opt/dbamon/adm/dbamonrc$modesuf | awk '{ print \$2 }'`);

#---- Read possible other email addresses
chop($report_email_raw = `grep '^Report_EMail:' /opt/dbamon/adm/dbamonrc$modesuf | awk '{ print \$0 }'`);
if ($report_email_raw)
{
  @words = split(/\s/,$report_email_raw); 
  $z = shift(@words);  #---- Get rid of the first word which is the verb
  $report_email = ""; 
  foreach (@words)
  {
    $report_email .= "$_ ";  
  }
  $report_email =~ s/^\s//g; 
  $report_email =~ s/\s$//g; 
}

$email = "$admin_email $report_email";
##&msg("DEBUG - report_email_raw=$report_email_raw report_email=($report_email) email=($email)"); 

$arg1 = $ARGV[1];
$arg2 = $ARGV[2];
$arg3 = $ARGV[3];
$arg4 = $ARGV[4];
#$arg5 = $ARGV[5];
#$arg6 = $ARGV[6];
#$arg7 = $ARGV[7];
#$arg8 = $ARGV[8];
$email = $admin_email if $arg1 ne "";

&msg("mode=$mode");
if ($mode ne "TEST" && $mode ne "PROD")
{
  print "$P | Usage: $0 {test | prod}\n";
  exit 1;
}

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    ##return "bgcolor=ffffff";
    return "bgcolor=white";
  }
  else
  {
    $lastbg = 1;
    ##return "bgcolor=$color_ro";
    return "bgcolor=lightgoldenrodyellow";
  }
}

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = @_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub msgOld
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  ($errmsg,$errorrc,$nomail) = @_;

  ($er_package, $er_filename, $er_line) = caller;
  $callermsg = "Calling er_package=$er_package er_filename=$er_filename er_line=$er_line";

  &msg("=============================================================");
  &msg("Fatal Error: $errmsg");
  &msg("Caller Info: $callermsg");
  &msg("SQL Error:   $DBI::errstr");
  &msg("MR SQL:      $sql") if $sql;
  &msg("=============================================================");
  &msg("Exiting rc=1");

  system("echo '$callermsg $DBI::errstr' | dbamon_mailer -s '$P - $errmsg' $admin_email") unless $nomail;

  if ($errorrc eq "") { exit 1; }
  else                { exit $errorrc; }
}

#------------------------------------------------------------------------------
sub connectDBOld
#------------------------------------------------------------------------------
{
  &msg("Connecting to DB");
  use DBI;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $os;

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 4000;
}

#-----------------------------------------------------------------------------
sub sumRpt2
#-----------------------------------------------------------------------------
{
  &msg("Selecting");

  print RPT "<h5><hr>DBAmon Event Summary - Last $days Days - By DBMS (Rpt2)</h5>\n";

  print RPT "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print RPT "<tr bgcolor=slate><th><font size=2>DBMS</font><th><font size=2>Event Count</font><th><font size=2>% Of Total</font>\n";

  $statement  = "
select
  count(*)
from 
  dbamon.events
where 
  ts >= sysdate - $days
      and dbamonmode like 'prod%'
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $daystot = $Data[0];
  }

  $statement  = "
    select
      dbms, 
      count(*)
    from 
      dbamon.events
    where 
      ts >= sysdate - $days
      and dbamonmode like 'prod%'
      and ticket != 'SD'
    group by
      dbms
    order by 
      2 desc ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $dbms = $Data[0];
    $cnt  = $Data[1];

    $pct = ($cnt / $daystot) * 100;
    $pct = sprintf("%11.1f",$pct);
    #printf RPT "%-16s %11.0f %11.1f%% \n",$dbms,$cnt,$pct;
    print RPT "<tr>
       <td><font size=2>$dbms<td align=right><font size=2>$cnt<td align=right><font size=2>${pct}%</font>\n";
    
  }

  print RPT "<tr bgcolor=slate><td><font size=2><b>Total:<td align=right><font size=2>$daystot\n";
  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
  &msg("Total events: $daystot");
}

#-----------------------------------------------------------------------------
sub sumRpt5
#-----------------------------------------------------------------------------
{
  &msg("sumRpt5 - Selecting");

  print RPT "
  <a name=rpt5>
  <h5><hr>DBAmon Critical Event Summary - Grouped By MsgID - Last 24 Hours (Rpt5)</h5>
  <table border=0 bgcolor=$color_ba>
  <tr bgcolor=$color_th>
    <th $style_m>MsgId
    <th $style_m colspan=2>Event Count
  "; 

  $statement  = "
    select
      msgid,
      count(*)
    from 
      dbamon.event_history
    where 
     --ts >= sysdate - 1
     datediff(hour,ts,getdate()) <= 24
      and dbamonmode like 'prod%'
    group by
      msgid 
    --having count(*) > 4
    order by
      2 desc";

  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Select_222');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $msgid = $Data[0];
    $count = $Data[1];

    $total += $count;

    $z = $count ;

    print RPT "<tr bgcolor=$color_ro>
       <td $style_m>$msgid
       <td $style_m align=right>$count  
       <td><img src='$img' height=15 width=$z>
    ";
  }

  print RPT "<tr bgcolor=$color_th><td $style_m><b>Total:<td $style_m align=right>$total\n";
  print RPT "</table>\n";

  $daytotal = $total;

  &msg("Selected $selectcount rows - daytotal=$daytotal");
}

#-----------------------------------------------------------------------------
sub sumRpt5d
#-----------------------------------------------------------------------------
{
  &msg("sumRpt5d - Selecting");

  print RPT "<a name=rpt5d>\n";
  print RPT "<h5><hr>DBAmon Critical Event Summary - Grouped By Instance And MsgID - Last 24 Hours (Rpt5d)</h5>\n";

  print RPT "<table border=0 bgcolor=$color_ba>
    <tr bgcolor=$color_th>
    <th $style_m>Instance
    <th $style_m>Msgid
    <th $style_m colspan=2>Event Count
  "; 

  $sql  = "
    select
      title,
      msgid,
      count(*)
    from 
      dbamon.event_history
    where 
      --ts >= sysdate - 1 
      datediff(hour,ts,getdate()) <= 24
      and dbamonmode like 'prod%'
    group by
      title,
      msgid 
    --having count(*) > 4
    order by
      2";

  ##print "$statement\n";

  $sth = $dbh->prepare($sql) || &error('Select_306');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $title = $Data[0];
    $msgid = $Data[1];
    $count = $Data[2];

    $total += $count;

    $z = $count ;

    $bg = &bg;
    print RPT "<tr $bg>
       <td $style_m>$title
       <td $style_m>$msgid
       <td $style_m align=right>$count  
       <td $style_m><img src='$img' height=15 width=$z>
    ";
  }

  print RPT "<tr bgcolor=$color_th><td $style_m><b>Total:<td $style_m align=right>$total\n";
  print RPT "</table>\n";

  $daytotal = $total;

  &msg("Selected $selectcount rows - daytotal=$daytotal");
}

#-----------------------------------------------------------------------------
sub sumRpt3
#-----------------------------------------------------------------------------
{
  &msg("sumRpt3 - Selecting");

  print RPT "<a name=rpt3>\n";
  print RPT "<h5><hr>DBAmon Critical Event Summary - Grouped By MsgID - Last Week (Rpt3)</h5>\n";

  print RPT "
  <table border=0 bgcolor=$color_ba>
  <tr bgcolor=$color_th>
    <th $style_m>DBMS
    <th $style_m colspan=2>Event Count
  "; 

  $statement  = "
    select
      msgid,
      count(*)
    from 
      dbamon.event_history
    where 
      --ts >= sysdate - 7 
      datediff(hour,ts,getdate()) <= (7*24)
      and dbamonmode like 'prod%'
    group by
      msgid
    order by
      2 desc ";

  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $msgid = $Data[0];
    $count = $Data[1];

    $total += $count;

    $z = $count;

    $bg = &bg;
    print RPT "<tr $bg>
       <td $style_m>$msgid
       <td $style_m align=right>$count  
       <td $style_m><img src='$img' height=15 width=$z>
    ";
  }

  print RPT "<tr bgcolor=$color_th><td $style_m><b>Total:<td $style_m align=right>$total\n";
  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
}


#-----------------------------------------------------------------------------
sub sumRpt3d
#-----------------------------------------------------------------------------
{
  &msg("sumRpt3d - Selecting");

  print RPT "<a name=rpt3d>\n";
  print RPT "<h5><hr>DBAmon Critical Event Summary - Grouped By Instance And MsgID - Last Week (Rpt3d)</h5>\n";

  print RPT "<table border=0 bgcolor=$color_ba>
  <tr bgcolor=$color_th>
    <th $style_m>Instance
    <th $style_m>MsgId
    <th $style_m colspan=2>Event Count
  ";

  $statement  = "
    select
      title,
      msgid,
      count(*)
    from 
      dbamon.event_history
    where 
      --ts >= sysdate - 7 
      datediff(hour,ts,getdate()) <= (7*24)
      and dbamonmode like 'prod%'
    group by
      title,
      msgid
    --having count(*) > 4
    order by
      3 desc ";

  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $title   = $Data[0];
    $msgid   = $Data[1];
    $count   = $Data[2];

    $total += $count;

    $z = $count;

    $bg = &bg;
    print RPT "<tr $bg>
       <td $style_m>$title
       <td $style_m>$msgid
       <td $style_m align=right>$count  
       <td><img src='$img' height=15 width=$z>
    ";
  }

  print RPT "<tr bgcolor=$color_th><td $style_m><b>Total:<td $style_m align=right>$total\n";
  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
}

#-----------------------------------------------------------------------------
sub sumRpt3e
#-----------------------------------------------------------------------------
{
  &msg("sumRpt3e - Selecting");

  $having_count = 10; 

  print RPT "<a name=rpt3d>\n";
  print RPT "<h5><hr>DBAmon Critical Event Summary - Grouped By Instance And MsgID - Last Six Months - (Having count(*) >= $having_count) (Rpt3e)</h5>\n";

  print RPT "<table border=0 bgcolor=$color_ba>
  <tr bgcolor=$color_th>
    <th $style_m>Instance
    <th $style_m>MsgId
    <th $style_m>Event Text
    <th $style_m colspan=2>Event Count
  ";

  $sql  = "
    select
      title,
      msgid,
      text,
      count(*)
    from 
      dbamon.event_history
    where 
      -- ts >= sysdate - 180 
      datediff(day,ts,getdate()) <= 180
      and dbamonmode like 'prod%'
    group by
      title,
      msgid,
      text
    having count(*) >= $having_count
    order by
      4 desc ";

  $sth = $dbh->prepare($sql) || &error('Select_493');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $title   = $Data[0];
    $msgid   = $Data[1];
    $text    = $Data[2];
    $count   = $Data[3];

    $total += $count;

    $z = $count;

    $bg = &bg;
    print RPT "<tr $bg>
       <td $style_m>$title
       <td $style_m>$msgid
       <td $style_s>$text
       <td $style_m align=right>$count  
       <td $style_m><img src='$img' height=15 width=$z>
    ";
  }

  print RPT "<tr bgcolor=$color_th><td $style_m><b>Total:<td $style_m align=right>$total\n";
  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
}

#-----------------------------------------------------------------------------
sub sumRpt6
#-----------------------------------------------------------------------------
{
  &msg("sumRpt6 - Selecting");

  print RPT "<a name=rpt6>\n";
  print RPT "<h5><hr>DBAmon Critical Event Report - Count Grouped By Date - Last 180 Days (Rpt6)</h5>\n";

  print RPT "
  <table border=0 bgcolor=$color_ba> 
  <tr bgcolor=$color_th>
    <th $style_m>DBMS
    <th $style_m colspan=2>Event Count
  ";

  $sql  = "
    select
      --to_char(ts,'YYYY/MM/DD') newts,
      dbamon.dateconvert_10(ts) as newts,
      count(*)
    from 
      dbamon.event_history
    where 
      --ts >= sysdate - 180 
      datediff(day,ts,getdate()) <= 180
      and dbamonmode like 'prod%'
      --and ticket is null
    group by
      --to_char(ts,'YYYY/MM/DD') 
      dbamon.dateconvert_10(ts)
    order by 1 desc
    ";

  $sth = $dbh->prepare($sql) || &error('Select_551');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $date  = $Data[0];
    $count = $Data[1];

    $total += $count;

    $z = $count;

    $bg = &bg;
    print RPT "<tr $bg>
       <td $style_m>$date
       <td $style_m align=right>$count  
       <td><img src='$img' height=15 width=$z>
    ";
  }

  print RPT "<tr bgcolor=$color_th><td $style_m><b>Total:<td $style_m align=right>$total\n";
  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
}

#-----------------------------------------------------------------------------
sub sumRpt4
#-----------------------------------------------------------------------------
{
  &msg("sumRpt4 - Selecting");

  print RPT "<a name=rpt4>\n";
  print RPT "<h5><hr>DBAmon Critical Event Report - Count Grouped By Month - Last Year (Rpt4)</h5>\n";

  print RPT "<table border=0 bgcolor=$color_ba> 
  <tr bgcolor=$color_th>
    <th $style_m>DBMS
    <th $style_m colspan=2>Event Count
  "; 

  $sql  = "
    select
      --to_char(ts,'YYYY/MM') newts,
      substring(dbamon.dateconvert_19(ts),1,7),
      count(*)
    from 
      dbamon.event_history
    where 
      --ts >= sysdate - 365 
      datediff(day,ts,getdate()) <= 365
      and dbamonmode like 'prod%'
      --and ticket is null
    group by
      --to_char(ts,'YYYY/MM') 
      substring(dbamon.dateconvert_19(ts),1,7)
    order by 1 desc
  ";

  $sth = $dbh->prepare($sql) || &error('Select_606');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $date  = $Data[0];
    $count = $Data[1];

    $total += $count;

    $z = $count ;
    $z = 1000 if $z > 1000; 

    $bg = &bg;
    print RPT "<tr $bg>
       <td $style_m>$date
       <td $style_m align=right>$count  
       <td $style_m><img src='$img' height=15 width=$z>
    ";
  }

  print RPT "<tr bgcolor=$color_th><td $style_m><b>Total:<td $style_m align=right>$total\n";
  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
}


#-----------------------------------------------------------------------------
sub msgidRpt
#-----------------------------------------------------------------------------
{
  &msg("Selecting");

  print RPT "<a name=rptmsgid>\n";
  print RPT "<h5><hr>DBAmon MsgId Legend</h5>\n";

  print RPT "<table border=0 bgcolor=$color_ba>
    <tr bgcolor=$color_th>
    <th $style_m>MsgId
    <th $style_m>Example Text
  ";

  $sql  = "
select
  msgid,
  min(text)
from 
  dbamon.event_history
group by
  msgid
order by 1
  ";
  $sth = $dbh->prepare($sql) || &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $msgid = $Data[0];
    $text  = $Data[1];

    $bg = &bg;
    printf RPT "<tr $bg>
      <td $style_m><b>$msgid </b>
      <td $style_m>$text
    ";
  }

  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
}

#-----------------------------------------------------------------------------
sub sumRpt
#-----------------------------------------------------------------------------
{
  &msg("Selecting");

  print RPT "<h5><hr>DBAmon Event Count - Last $days Days</h5>\n";

  print RPT "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print RPT "<tr bgcolor=slate>
    <th><font size=2>Date</font>
    <th><font size=2>DBMS</font>
    <th><font size=2>Event Count</font>\n";

  $statement  = "
select
  to_char(ts,'YYYY/MM/DD') newts,
  dbms, 
  count(*)
from 
  dbamon.events
where 
  ts >= sysdate - $days
      and dbamonmode like 'prod%'
group by
  to_char(ts,'YYYY/MM/DD') ,
  dbms
order by 
  1 desc ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $date = $Data[0];
    $dbms = $Data[1];
    $cnt  = $Data[2];

    if ($date ne $lastdate && $lastdate ne "")
    {
      printf RPT "<tr><td><td><td bgcolor=slate align=right ><font size=2><b>Day Total:</b> $dsubcnt \n";
      $dsubcnt = 0;
    }

    printf RPT "<tr>
      <td><font size=2>$date
      <td><font size=2>$dbms
      <td align=right><font size=2>$cnt \n";

    $dtotal  += $cnt;
    $dsubcnt += $cnt;
    $lastdate = $date;
  }

  printf RPT "<tr><td><td><td bgcolor=slate align=right><font size=2><b>Day Total:</b> $dsubcnt \n";

  printf RPT "<tr bgcolor=slate><th><font size=2>Total:<td><td align=right><font size=2>$dtotal\n";;
  print RPT "</table>\n";

  &msg("Selected $selectcount rows");
  &msg("Total events: $dtotal");
}

#-----------------------------------------------------------------------------
sub detailRpt
#-----------------------------------------------------------------------------
{
  &msg("Selecting");

  print RPT "<h5><hr>DBAmon Event Detail - Last 24 Hours</h5>\n";

  print RPT "<table border=0 bgcolor=$color_ba  >
  <tr bgcolor=$color_th>
        <th $style_m>Instance
        <th $style_m>DBMS
        <th $style_m>Severity
        <th $style_m>Event Count
  ";

  $statement  = "select
      instance,
      dbms,
      sev,
      count(*)
    from 
      dbamon.events
    where 
      --ts >= sysdate - 1
      datediff(hour,ts,getdate()) <= 24
      and dbamonmode like 'prod%'
    group by
      instance,
      dbms,
      sev
    order by 
      4 desc";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $inst = $Data[0];
    $dbms = $Data[1];
    $sev  = $Data[2];
    $cnt  = $Data[3];
    $firstinst = "$inst($dbms)" if $firstinst eq "";
    #printf RPT "%-28s %-16s %-4s %11.0f \n",$inst,$dbms,$sev,$cnt;

    printf RPT "<tr bgcolor=$color_ro>
      <td $style_m>$inst
      <td $style_m>$dbms
      <td $style_m>$sev
      <td $style_m align=right>$cnt
    ";

    ##print "DEBUG: $zdat $inst $dbms $cat $parm $val \n";
    $total += $cnt;
  }
  printf RPT "<tr bgcolor=$color_th>
      <th $style_m>Total:
      <td $style_m>
      <td $style_m>
      <td align=right>$total
  ";
  print  RPT "</table> \n";

  &msg("Selected $selectcount rows");
  &msg("Total events: $total");
}

#-----------------------------------------------------------------------------
sub instanceRpt
#-----------------------------------------------------------------------------
{
  &msg("instanceRpt - Starting");

  print RPT "<h5><hr>DBAmon Instances Report (instanceRpt)</h5>
  <a name=instanceRpt>
  For more information see: 
  <a href='${www_base}/dbamon/dbamon_sys.html'><b>DBAmon Instance Summary</b></a> 
  .  <br> 
  ";

  print RPT "<table border=0 bgcolor=$color_ba  > 
  <tr bgcolor=$color_th>
    <th><span $style_m>Server / Instance 
    <th><span $style_m>DBMS / Version 
    <th><span $style_m>DB Disk Space<br>Used GB / Allocated GB 
  ";

  $sql = "select
      system,
      instance,
      dbms,
      dbmsver,
      used,
      alloc
    from 
      dbamon.instances
    where 
      dbamonmode like 'prod%'
    order by 
      1, 2";
  $sth = $dbh->prepare($sql) || &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $system   = shift @Data;
    $instance = shift @Data;
    $dbms     = shift @Data;
    $dbmsver  = shift @Data;
    $used     = shift @Data;
    $alloc    = shift @Data;

    $bg = &bg;
    printf RPT "<tr $bg> <span $style_m> 
      <td><b> $system / $instance </b>
      <td>$dbms   / $dbmsver
      <td align=right>$used   / $alloc 
    ";
  }

  $instance_count = $selectcount; 

  print  RPT "</table> 
    <h5>Total DBAmon Mode=PROD Instances: $instance_count</h5>
  ";

  &msg("Selected $selectcount rows");
  &msg("instanceRpt - Done");  
}

#-----------------------------------------------------------------------------
sub detailRpt2
#-----------------------------------------------------------------------------
{
  &msg("detailRpt2 - Selecting");
  $detdays = 7; 

  print RPT "
  <h5><hr>DBAmon Event Detail - Last $detdays Days - All Mode=PROD and Mode=TEST Instances (detailRpt2)</h5>
  <a name=detailRpt2>
  <table border=0 bgcolor=$color_ba  >
  <tr bgcolor=$color_th>
        <th $style_m>Timestamp
        <th $style_m>Event Source
        <th $style_m>Instance
        <th $style_m>DBMS
        <th $style_m>Severity
        <th $style_m>MsgId
        <th $style_m>Event Text
  ";

  $sql  = "select
      dbamon.dateconvert_19(ts),
      instance,
      dbms,
      sev,
      msgid,
      text,
      source
    from 
      --dbamon.event_history
      dbamon.events
    where 
      --datediff(hour,ts,getdate()) <= ($detdays*24)
      ts between dateadd(dd,-$detdays,getdate()) and getdate() 
      -- and dbamonmode like 'prod%'   RE-ADD this when you go back to event_history
      and ticket != 'SD'
    order by 
      1 desc ";
  $sth = $dbh->prepare($sql) || &error('Select_973');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $ts   = shift(@Data); 
    $inst = shift(@Data); 
    $dbms = shift(@Data); 
    $sev  = shift(@Data); 
    $msgid= shift(@Data); 
    $text = shift(@Data); 
    $source = shift(@Data); 

    #printf RPT "%-28s %-16s %-4s %11.0f \n",$inst,$dbms,$sev,$cnt;

    #---- $text could have a single percent which goofs up printf below. 
    $text =~ s/%/%%/g;

    if    ($sev eq "C") { $color_sev = "pink"; }
    elsif ($sev eq "W") { $color_sev = "yellow"; }
    elsif ($sev eq "P") { $color_sev = "lightskyblue"; }
    elsif ($sev eq "S") { $color_sev = "mediumpurple"; }
    elsif ($sev eq "I") { $color_sev = "cyan"; }
    elsif ($sev eq "N") { $color_sev = "lime"; }
    elsif ($sev eq "U") { $color_sev = "#99cc00"; }
    else                { $color_sev = $color_ro;  }

    printf RPT "<tr bgcolor=$color_sev>
      <td $style_m nowrap>$ts
      <td $style_m nowrap>$source
      <td $style_m><b> $inst </b>
      <td $style_m>$dbms
      <td $style_m>$sev
      <td $style_m>$msgid
      <td $style_m>$text
    ";

    ##print "DEBUG: $zdat $inst $dbms $cat $parm $val \n";
  }
  printf RPT "<tr bgcolor=$color_th>
      <th $style_m >Total Events:
      <td $style_m align=right>$selectcount
      <th $style_m colspan=5>
  ";
  print  RPT "</table> \n";

  &msg("detailRpt2 - Selected $selectcount rows");
}

#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  &msg("init - Starting"); 
  chop($hostname = `hostname`);
  chop($date = `date`);

  if ($www_base)
  {
    $dbamon_url = "${www_base}/dbamon/dbamon_sys.html"; 
  }
  else
  {
    $dbamon_url = "http://$hostname/dbamon/dbamon_sys.html"; 
    $www_base   = "http://$hostname/"; 
  }

  msg("Opening output RPT file: $tmpflrpt");
  system("rm $tmpflrpt 2>/dev/null");
  open(RPT, ">$tmpflrpt") || &error("Can't open output $tmpflrpt - $!");

  #msg("Opening output EMAILHDR file: $tmpflemail");
  #system("rm $tmpflemail 2>/dev/null");
  #open(EMAILHDR, ">$tmpflemail") || &error("Can't open output $tmpflemail - $!");

  &msg("www_base=$www_base hostname=$hostname dbamon_url=$dbamon_url"); 
  &msg("init - Done"); 
}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting mode=$mode arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4 - hostname=$hostname");

&connectDB;
&init;

## Make header
#&sumRpt5; 
##&detailRpt; 
#close(RPT);
#system("rm $tmpflrpt $tmpflemail");
#$firstinst =~ s/ //g;

#print EMAILHDR "Subject: ***[DBAmon Report]*** Events - $daytotal Critical Events During Last 24 Hours [AUTO]\n";
#print EMAILHDR "Content-type: text/html \n\n";

#print EMAILHDR "
#<html>
#<font face=$font size=2>
#<table border=0 width=90%>
#<tr bgcolor=darkblue><td><center><font color=white size=6>DBAmon</font></center>
#<tr bgcolor=wheat><td><center><b>Daily Event Reports - As Of: $date</b></center>
#</table> \n";
#print EMAILHDR "<p><center>In an effort to conserve Network and EMail bandwidth, this report is now
#available on the WWW. 
#<p><a href='http://dba.it.thecompany.com/dba/data/reportcache/$P.html'><b>Click Here To View The Report</b></a>\n";
#close(EMAILHDR);

print RPT "
</pre>
<body bgcolor=$color_body>
<font face=$font size=2>
<table border=0 width=95%>
<tr bgcolor=darkblue>
  <td style='font-family:verdana;font-size:48;color=white;'>
  <center><font color=white>
  DBAmon
  </center>
<tr bgcolor=wheat>
  <td $style_l>
  <center>
    <b>  Daily Event Reports - As Of: $date </b>
  </center>
</table> 
   <p>
<span $style_m>To view the current DBAmon list of instances monitored, go to:
  <a href='$dbamon_url'><b>DBAmon Instance Summary WWW Page</b></a> . 
   <br>
  <br><b>Reports:</b>
  <ul>
    <li><a href='#instanceRpt' ><b>All Instances</b></a>
    <li><a href='#rpt5' ><b>Critical Events - Last 24 Hours - By MsgId</b></a>
    <li><a href='#rpt5d'><b>Critical Events - Last 24 Hours - By Instance And MsgId</b></a>
    <li><a href='#rpt3' ><b>Critical Events - Last 7 Days - By MsgId</b></a>
    <li><a href='#rpt3d'><b>Critical Events - Last 7 Days - By Instance And MsgId</b></a>
    <li><a href='#rpt4' ><b>Critical Events - Last Year - By Month</b></a>
    <li><a href='#rpt6' ><b>Critical Events - Last 90 Days - By Date (NEW)</b></a>
    <li><a href='#detailRpt2' ><b>All Events - Last 7 Days - All Instances </b></a>
    <li><a href='#rptmsgid' ><b>DBAmon MsgId Legend</b></a>
  </ul>
  ";

#---- Reports to run:
&instanceRpt;
&sumRpt5; 
&sumRpt5d; 
&sumRpt3; 
&sumRpt3d; 
&sumRpt3e; 
&sumRpt4; 
&sumRpt6; 
&detailRpt2; 
&msgidRpt; 

#&sumRpt2; 
#&sumRpt; 
#&detailRpt; 

#---- Close report file
print RPT "<hr><h5>(End of Report)</h5>\n"; 
close(RPT);

#---- Send email
&msg("Sending report to $email");
system("ls -l $tmpflrpt");
##system("(cat $tmpflemail\;cat $tmpflrpt) | dbamon_mailer -h -s '[DBAmon Report] Daily Event Report - $daytotal Critical Events During Last 24 Hours' $email"); 
system("cat $tmpflrpt | dbamon_mailer -h -s '[DBAmon Report] Daily Event Report - Critical Events (Last 24 Hours): $daytotal - Instances Being Monitored: $instance_count' $email"); 

if ( -e "/opt/web/dba/data/reportcache") 
{
  $cachefile = "/opt/web/dba/data/reportcache/$P.html";
  &msg("Copying report body to / email header to $cachefile");
  system("cp $tmpflrpt $cachefile");
}

system("rm $tmpflrpt");

&msg("Done");
exit 0;
