# -----------------------------------------------------------------------------
sub oraAlerts
{
  ($thishost) = @_;
  #
  # Get Instance online data
  #

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  # Return if they don't want age checking for this instance
  if ($alert_log_check[$thishost] eq "N")
  {
    logit("Alert Log Checking not requested for this instance (DBC Alert_Log_Check: is N)",$thishost);
    return 0;
  }

  $foundalerts = "";

  &logDetails($thishost,"<h3>Oracle Alert Log (last 50 lines)</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=antiquewhite><tr><td><pre>");

  @lines = split(/\n/,$oraAlertsStack[$thishost]);

  $all_alerts = ""; 
  foreach (@lines)
  {
    $all_alerts .= substr($_,22) . "\n";
  }

  foreach (@lines)
  {
    ##print "oraalertsStack: $_ \n";
    &parse;

    if ($F3 eq "alerttext:") 
    {
      $z = substr($F0,33);
      &logDetails($thishost,$z);
    }

    if ($F5 eq "ALERT") 
    {
      open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
      print TMPFL6 "$all_alerts";
      close(TMPFL6);

      ##system("ll $tmpfl6"); 
      ##system("cat $tmpfl6"); 

      &event("C",$thishost,"Critical Messages Found in Oracle Alert Log","CritMsg","DBA610C",$tmpfl6);
      $foundalerts = 1;
    } 
  }

  &logDetails($thishost,"</pre></table><hr>");

  if ($foundalerts eq "")
  {
    &logit("OK",$thishost);
  }
}
# -----------------------------------------------------------------------------
1;
