#-----------------------------------------------------------------------------
#
# sumupdate Routines - Formerly a pgm in bin (dbamon_sumupdate)
#
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
sub insertDetail
#-----------------------------------------------------------------------------
{
  #---- BB 2014/01/27 - I don't think this is ever used. Look at sumprint. 
  if ($arg4 eq "") {$arg4 = 0;}
  $statement  = "
    insert into dbamon.summary_detail
      (dbamonmode,system,dbms,title,spacealloc,htmlstring) 
    values 
    (\'$summode\',\'$arg1\', \'$arg2\', \'$arg3\', \'$arg4\', \'$arg5\')
  ";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
  &msg("Row inserted") if $debug_summarize;
}

#-----------------------------------------------------------------------------
sub deleteDetail
#-----------------------------------------------------------------------------
{
  $statement  = "delete from dbamon.summary_detail where dbamonmode like '$summode'";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_delete');
  &msg("All summary_detail rows deleted") if $debug_summarize;

  $statement  = "delete from dbamon.event_detail where dbamonmode like '$summode'";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_delete');
  &msg("All event_detail rows deleted") if $debug_summarize;
}

#-----------------------------------------------------------------------------
sub insertTot
#-----------------------------------------------------------------------------
{
  $statement  = "
    insert into dbamon.summary_tot
      (dbamonmode,text,count,color) 
    values 
    (\'$summode\',\'$arg1\', \'$arg2\', \'$arg3\')
  ";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
  &msg("Row inserted") if $debug_summarize;
}

#-----------------------------------------------------------------------------
sub deleteTot
#-----------------------------------------------------------------------------
{
  $statement  = "delete from dbamon.summary_tot where dbamonmode like '$summode'";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_delete');
  &msg("All rows deleted") if $debug_summarize;
}

#-----------------------------------------------------------------------------
sub insertDBMS
#-----------------------------------------------------------------------------
{
  if ($arg5 && $arg6)
  {
    $statement  = "
      insert into dbamon.summary_dbms
	(dbamonmode,
	 dbms,
	 count,
	 v_low,
	 v_high,
	 db_count,
	 gb_alloc) 
      values 
      (\'$summode\',
       \'$arg1\', 
       \'$arg2\', 
       \'$arg3\', 
       \'$arg4\',
       \'$arg5\',
       \'$arg6\')
    ";
  }
  else
  {
  $statement  = "
    insert into dbamon.summary_dbms
      (dbamonmode,
       dbms,
       count,
       v_low,
       v_high,
       db_count,
       gb_alloc) 
    values 
    (\'$summode\',
     \'$arg1\', 
     \'$arg2\', 
     \'$arg3\', 
     \'$arg4\',
     null, 
     null)
    ";
  }

  &msg("statement=$statement") if $debug_summarize;

  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
  &msg("Row inserted") if $debug_summarize;
}

#-----------------------------------------------------------------------------
sub insertTask
#-----------------------------------------------------------------------------
{
  $statement  = "
    insert into dbamon.task
      (dbamonmode,pid,starttime_num,starttime_char,alpha,iter_num,iter_dur,num_instances) 
    values 
    (\'$summode\',\'$arg1\', \'$arg2\', \'$arg3\', \'$arg4\', \'$arg5\',\'$arg6\',\'$arg7\')
  ";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
  &msg("Row inserted") if $debug_summarize;
}

#-----------------------------------------------------------------------------
sub deleteDBMS
#-----------------------------------------------------------------------------
{
  &msg("Deleting from summary_dbms") if $debug_summarize;
  $statement  = "delete from dbamon.summary_dbms where dbamonmode like '$summode'";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_delete');
  &msg("All rows deleted") if $debug_summarize;
}

#-----------------------------------------------------------------------------
sub deleteTask
#-----------------------------------------------------------------------------
{
  &msg("Deleting from task") if $debug_summarize;
  $statement  = "delete from dbamon.task where dbamonmode like '$summode'";
  ##print "statement=$statement\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_delete');
  &msg("All rows deleted") if $debug_summarize;
}

#-----------------------------------------------------------------------------
sub deleteStartup
#-----------------------------------------------------------------------------
{
  $sql = "delete from dbamon.dbcactive where dbamonmode like '$summode'";
  &msg("Deleting from dbamon.dbcactive - sql=$sql") if $debug_summarize;
  $rc = $dbh->do($sql) || &error('Failed_on_DB_do_delete');
  &msg("All rows deleted") if $debug_summarize;

  $sql = "delete from dbamon.instances where dbamonmode like '$summode'";
  &msg("Deleting from dbamon.instances - sql=$sql") if $debug_summarize;
  $rc = $dbh->do($sql) || &error('Failed_on_DB_do_delete');
  &msg("All rows deleted") if $debug_summarize;

  $sql = "delete from dbamon.instance_details where instance_key like '$summode'";
  &msg("Deleting from dbamon.instance_details - sql=$sql") if $debug_summarize;
  $rc = $dbh->do($sql) || &error('Failed_on_DB_do_delete');
  &msg("All rows deleted") if $debug_summarize;
}

#-----------------------------------------------------------------------------
sub sumupdate
#-----------------------------------------------------------------------------
{
  $verb = $_[0];
  $arg1 = $_[1];
  $arg2 = $_[2];
  $arg3 = $_[3];
  $arg4 = $_[4];
  $arg5 = $_[5];
  $arg6 = $_[6];
  $arg7 = $_[7];

  $debug_summarize = 0; 
  &msg("sumupdate - Starting verb=$verb summode=$summode arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4") if $debug_summarize || $ENV{'BATCH_MODE'};

  if ($verb eq "D") 
  { 
    &deleteDetail; 
    &deleteTot; 
    &deleteDBMS; 
  }

  if ($verb eq "DS") 
  { 
    $debug_summarize = 1;
    if ($ENV{'BATCH_MODE'}) { $summode = $ENV{'BATCH_MODE'}. '%'; }
    else                    { $summode = 'prod%'; }
    &deleteDetail; 
    &deleteTot; 
    &deleteDBMS; 
    &deleteTask; 
    &deleteStartup; 
  }

  if ($verb eq "I") 
  { 
    &insertDetail; 
  }

  if ($verb eq "T") 
  { 
    &insertTot; 
  }

  if ($verb eq "S") 
  { 
    &insertDBMS; 
  }

  if ($verb eq "Task") 
  { 
    &insertTask; 
  }
}

1;
